/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package rutherford;

import java.awt.Color;
import java.awt.geom.Point2D;
import java.util.Random;

/**
 *
 * @author Mikulas_s_capicu
 */
class DetailCastica {

    static private Point2D.Double[] stredyAtomov = {new Point2D.Double(52, 41), new Point2D.Double(151, 41),
                                                   new Point2D.Double(52, 135), new Point2D.Double(151, 135),
                                                   new Point2D.Double(52, 229), new Point2D.Double(151, 229)};
    static private Point2D.Double predchadzajuciVratenyStred = null;

    double x, y, polomer;
    double dx, dy, zmenaPolomeru;
    double buduceDx, buduceDy, buducaZmenaPolomeru;
    Color farba, buducaFarba;

    public DetailCastica(AlfaCastica alfa){
        polomer = 15;
        dx = 0;
        dy = 0;
        zmenaPolomeru = -0.25;
        farba = Color.red;
        if (alfa.buduceDx == 1){
            Point2D.Double pom = vratSuradnicuCastice();
            buducaZmenaPolomeru = -0.08;
            buduceDx = 0;
            buduceDy = 0;
            x = pom.x;
            y = pom.y;
            buducaFarba = new Color(255,0,132);
        }else if (alfa.buduceDx == 0.9665){
            Point2D.Double pom = vratStredAtomu();
            buducaZmenaPolomeru = -0.08;
            buduceDx = 0;
            buduceDy = -1;
            x = pom.x;
            y = pom.y - 12;
            buducaFarba = new Color(255,0,132);
        }else if (alfa.buduceDx == 0.9683){
            Point2D.Double pom = vratStredAtomu();
            buducaZmenaPolomeru = -0.08;
            buduceDx = 0;
            buduceDy = 1;
            x = pom.x;
            y = pom.y + 12;
            buducaFarba = new Color(255,0,132);
        }else if (alfa.buduceDx == 0.6238){
            Point2D.Double pom = vratStredAtomu();
            buducaZmenaPolomeru = -0.08;
            buduceDx = 0;
            buduceDy = -3;
            x = pom.x;
            y = pom.y - 8;
            buducaFarba = new Color(255,0,132);
        }else if (alfa.buduceDx == 0.6349){
            Point2D.Double pom = vratStredAtomu();
            buducaZmenaPolomeru = -0.08;
            buduceDx = 0;
            buduceDy = 3;
            x = pom.x;
            y = pom.y + 8;
            buducaFarba = new Color(255,0,132);
        }else if (alfa.buduceDx == -0.5719){
            Point2D.Double pom = vratStredAtomu();
            buducaZmenaPolomeru = -zmenaPolomeru;
            buduceDx = 0;
            buduceDy = -3;
            x = pom.x;
            y = pom.y - 4;
            buducaFarba = Color.red;
        }else if (alfa.buduceDx == -0.5827){
            Point2D.Double pom = vratStredAtomu();
            buducaZmenaPolomeru = -zmenaPolomeru;
            buduceDx = 0;
            buduceDy = 3;
            x = pom.x;
            y = pom.y + 4;
            buducaFarba = Color.red;
        }else if (alfa.buduceDx == -0.9075){
            Point2D.Double pom = vratStredAtomu();
            buducaZmenaPolomeru = -zmenaPolomeru;
            buduceDx = 0;
            buduceDy = -1;
            x = pom.x;
            y = pom.y - 2;
            buducaFarba = Color.red;
        }else if (alfa.buduceDx == -0.9188){
            Point2D.Double pom = vratStredAtomu();
            buducaZmenaPolomeru = -zmenaPolomeru;
            buduceDx = 0;
            buduceDy = 1;
            x = pom.x;
            y = pom.y + 2;
            buducaFarba = Color.red;
        }else{
            Point2D.Double pom = vratStredAtomu();
            buducaZmenaPolomeru = -zmenaPolomeru;
            buduceDx = 0;
            buduceDy = 0;
            x = pom.x;
            y = pom.y;
            buducaFarba = Color.red;
        }
    }

    void nastavNoveZmeny(){
        dx = buduceDx;
        dy = buduceDy;
        zmenaPolomeru = buducaZmenaPolomeru;
        farba = buducaFarba;
    }

    void posunCasticu(){
        x += dx;
        y += dy;
        polomer += zmenaPolomeru;
    }

    private Point2D.Double vratStredAtomu(){
        Random rand = new Random();
        Point2D.Double stred;
        do{
            int pom = rand.nextInt(6);
            stred = stredyAtomov[pom];
        }while (stred.equals(predchadzajuciVratenyStred));

        predchadzajuciVratenyStred = stred;
        return stred;
    }

    private Point2D.Double vratSuradnicuCastice() {
        Random rand = new Random();
        int xx;
        int yy;
        do{
            xx = 20+ rand.nextInt(162);
            yy = 20+ rand.nextInt(229);
        }while (jeBlizkoKStredomAtomov(xx,yy));
        Point2D.Double result = new Point2D.Double(xx,yy);
        return result;
    }

    private boolean jeBlizkoKStredomAtomov(int x, int y) {
        for(int i = 0; i<stredyAtomov.length; i++){
            Point2D.Double pom = stredyAtomov[i];
            if ( Math.sqrt(Math.pow(pom.x - x,2) + Math.pow(pom.y - y,2)) < 20 ){
                return true;
            }
        }
        return false;
    }

}